stages:
  - build
  - deploy

build:
  stage: build
  image: node:lts
  script:
    # Install david.
    - npm i -g david
    # Check if dependencies are up-to-date.
    - david
    # Install dependencies.
    - npm ci
    # Check for vulnerabilities.
    - npm audit --audit-level=moderate
    # Build assets.
    - npm run build
    # Persist version to build directory.
    - echo $CI_COMMIT_SHA > build/version
  artifacts:
    name: build
    paths:
      - build

pages:
  dependencies:
    - build
  stage: deploy
  only:
    - master
    - schedules
  image: node:lts
  environment:
    name: production
  script:
    # Remove existing content in "public" folder.
    - rm -r public/*
    # Deploy to GitLab pages.
    - cp -r build/* public/
  artifacts:
    paths:
      - public
